<!-- README.md is generated from README.Rmd. Please edit that file -->

# arkhe <img width=120px src="man/figures/logo.png" align="right" />

<!-- badges: start -->

[![Code
coverage](https://packages.tesselle.org/arkhe/coverage/badge.svg)](https://packages.tesselle.org/arkhe/coverage/)
[![Dependencies](https://tinyverse.netlify.app/badge/arkhe)](https://cran.r-project.org/package=arkhe)

<a href="https://tesselle.r-universe.dev/arkhe"
class="pkgdown-devel"><img
src="https://tesselle.r-universe.dev/badges/arkhe"
alt="r-universe" /></a>
<a href="https://cran.r-project.org/package=arkhe"
class="pkgdown-release"><img
src="https://www.r-pkg.org/badges/version/arkhe"
alt="CRAN Version" /></a>
<a href="https://cran.r-project.org/web/checks/check_results_arkhe.html"
class="pkgdown-release"><img
src="https://badges.cranchecks.info/worst/arkhe.svg"
alt="CRAN checks" /></a>
<a href="https://cran.r-project.org/package=arkhe"
class="pkgdown-release"><img
src="https://cranlogs.r-pkg.org/badges/arkhe"
alt="CRAN Downloads" /></a>

[![Project Status: Active – The project has reached a stable, usable
state and is being actively
developed.](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active)

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.3526659.svg)](https://doi.org/10.5281/zenodo.3526659)
<!-- badges: end -->

## Overview

A dependency-free collection of simple functions for cleaning
rectangular data. This package allows to detect, count and replace
values or discard rows/columns using a predicate function. In addition,
it provides tools to check conditions and return informative error
messages.

------------------------------------------------------------------------

To cite arkhe in publications use:

Frerebeau N (2025). *arkhe: Tools for Cleaning Rectangular Data*.
Université Bordeaux Montaigne, Pessac, France.
<doi:10.5281/zenodo.3526659> <https://doi.org/10.5281/zenodo.3526659>, R
package version 1.11.0, <https://packages.tesselle.org/arkhe/>.

This package is a part of the tesselle project
<https://www.tesselle.org>.

## Installation

You can install the released version of **arkhe** from
[CRAN](https://CRAN.R-project.org) with:

``` r
install.packages("arkhe")
```

And the development version from [Codeberg](https://codeberg.org/) with:

``` r
# install.packages("remotes")
remotes::install_git("https://codeberg.org/tesselle/arkhe")
```

## Usage

``` r
## Load the package
library(arkhe)

## Set seed for reproductibility
set.seed(12345)

## Create a matrix
X <- matrix(sample(1:10, 25, TRUE), nrow = 5, ncol = 5)

## Add NA
k <- sample(1:25, 3, FALSE)
X[k] <- NA
X
#>      [,1] [,2] [,3] [,4] [,5]
#> [1,]    3    2    1    4    4
#> [2,]   10    6    8    8   10
#> [3,]    8   NA    7   10    7
#> [4,]   NA   NA    6    3    2
#> [5,]    8   10    1    9    4

## Count missing values in rows
count(X, f = is.na, margin = 1)
#> [1] 0 0 1 2 0

## Count non-missing values in columns
count(X, f = is.na, margin = 2, negate = TRUE)
#> [1] 4 3 5 5 5

## Find row with NA
detect(X, f = is.na, margin = 1)
#> [1] FALSE FALSE  TRUE  TRUE FALSE

## Find column without any NA
detect(X, f = is.na, margin = 2, negate = TRUE, all = TRUE)
#> [1] FALSE FALSE  TRUE  TRUE  TRUE

## Remove row with any NA
discard(X, f = is.na, margin = 1, all = FALSE)
#>      [,1] [,2] [,3] [,4] [,5]
#> [1,]    3    2    1    4    4
#> [2,]   10    6    8    8   10
#> [3,]    8   10    1    9    4

## Remove column with any NA
discard(X, f = is.na, margin = 2, all = FALSE)
#>      [,1] [,2] [,3]
#> [1,]    1    4    4
#> [2,]    8    8   10
#> [3,]    7   10    7
#> [4,]    6    3    2
#> [5,]    1    9    4

## Replace NA with zeros
replace_NA(X, value = 0)
#>      [,1] [,2] [,3] [,4] [,5]
#> [1,]    3    2    1    4    4
#> [2,]   10    6    8    8   10
#> [3,]    8    0    7   10    7
#> [4,]    0    0    6    3    2
#> [5,]    8   10    1    9    4
```

## Translation

This package provides translations of user-facing communications, like
messages, warnings and errors. The preferred language is by default
taken from the locale. This can be overridden by setting of the
environment variable `LANGUAGE` (you only need to do this once per
session):

``` r
Sys.setenv(LANGUAGE = "<language code>")
```

Languages currently available are English (`en`), French (`fr`) and
Spanish (`es`).

## Contributing

Please note that the **arkhe** project is released with a [Contributor
Code of Conduct](https://www.tesselle.org/conduct.html). By contributing
to this project, you agree to abide by its terms.

x <- rnorm(20)

## Bootstrap
bootstrap(x, do = mean, n = 100)

## Estimate the 25th and 95th percentiles
quant <- function(x) { quantile(x, probs = c(0.25, 0.75)) }
bootstrap(x, n = 100, do = mean, f = quant)

## Get the n bootstrap estimates
(z <- bootstrap(x, n = 100, do = mean, f = function(x) { x }))

## Basic bootstrap confidence interval
confidence_bootstrap(z, level = 0.95, type = "basic", t0 = mean(x))

## Create a data matrix
X <- matrix(sample(1:10, 25, TRUE), nrow = 5, ncol = 5)

## Add NA
k <- sample(1:25, 3, FALSE)
X[k] <- NA
X

## Count missing values in rows
count(X, f = is.na, margin = 1)
## Count non-missing values in columns
count(X, f = is.na, margin = 2, negate = TRUE)

## Seek columns
seek_columns(iris, select = startsWith, prefix = "Petal")
seek_columns(iris, names = c("Petal.Length", "Petal.Width"))

## Get columns
x <- get_columns(iris, select = startsWith, prefix = "Petal")
head(x)

x <- get_columns(iris, names = c("Petal.Length", "Petal.Width"))
head(x)

## Create a data matrix
X <- matrix(sample(1:10, 25, TRUE), nrow = 5, ncol = 5)

## Add NA
k <- sample(1:25, 3, FALSE)
X[k] <- NA
X

## Remove row with any NA
discard(X, f = is.na, margin = 1, all = FALSE)
## Remove column with any NA
discard(X, f = is.na, margin = 2, all = FALSE)

## Confidence interval for a mean
x <- seq(from = -4, to = 4, by = 0.01)
y <- dnorm(x)

mean(y)
confidence_mean(y, type = "student")
confidence_mean(y, type = "normal")

## Confidence interval for a propotion
confidence_binomial(118, n = 236)

x <- c(35, 74, 22, 69)
confidence_multinomial(x)

## Create a data matrix
X <- matrix(sample(LETTERS, 25, TRUE), nrow = 5, ncol = 5)

## Add empty string
k <- sample(1:25, 3, FALSE)
X[k] <- ""
X

## Remove rows with empty strings
remove_empty(X, margin = 1)

## Replace empty strings
replace_empty(X, value = "XXX")

# Append row names =============================================================
df <- data.frame(
  x = 1:5,
  y = 6:10,
  row.names = LETTERS[1:5]
)

df1 <- append_rownames(df, after = 3, remove = TRUE)
df2 <- data.frame(
  x = 1:5,
  y = 6:10,
  rownames = LETTERS[1:5]
)
expect_identical(df1, df2)

# Append column ================================================================
df <- data.frame(
  x = 1:5,
  y = 6:10,
  row.names = LETTERS[1:5]
)

col <- c(D = 44, E = 55, B = 22)
df1 <- append_column(df, col, after = 3, var = "new_col")
df2 <- data.frame(
  x = 1:5,
  y = 6:10,
  new_col = c(NA, 22, NA, 44, 55),
  row.names = LETTERS[1:5]
)
expect_identical(df1, df2)

expect_error(append_column(df, unname(col)))

col <- c(DD = 44, EE = 55, BB = 22)
df1 <- append_column(df, col, after = 3)
df2 <- data.frame(
  x = 1:5,
  y = 6:10,
  .col = c(NA_real_, NA_real_, NA_real_, NA_real_, NA_real_),
  row.names = LETTERS[1:5]
)
expect_identical(df1, df2)

# Validate =====================================================================
expect_null(validate(mean(c(1,2, 3))))
expect_inherits(validate(mean(c("a", "b", "c"))), "character")
expect_length(validate(mean(c("a", "b", "c"))), 1)

# Missing package ==============================================================
cnd <- arkhe:::catch_conditions(assert_package("ABC123XYZ", ask = FALSE))
expect_inherits(cnd[[1]], "error_missing_package")

# Assert type ==================================================================
cnd <- arkhe:::catch_conditions(assert_type(NULL, expected = "numeric"))
expect_inherits(cnd[[1]], "error_bad_type")

x <- numeric()
cnd <- arkhe:::catch_conditions(assert_type(x, expected = "numeric", allow_empty = FALSE))
expect_inherits(cnd[[1]], "error_bad_dimensions")

cnd <- arkhe:::catch_conditions(assert_type(x, expected = "character"))
expect_inherits(cnd[[1]], "error_bad_type")

expect_identical(assert_type(x, expected = "numeric"), x)
expect_null(assert_type(NULL, expected = "numeric", allow_null = TRUE))

# Assert scalar ================================================================
x <- numeric(3)
cnd <- arkhe:::catch_conditions(assert_scalar(x, expected = "character"))
expect_inherits(cnd[[1]], "error_bad_scalar")

y <- numeric(1)
cnd <- arkhe:::catch_conditions(assert_scalar(y, expected = "character"))
expect_inherits(cnd[[1]], "error_bad_scalar")

expect_identical(assert_scalar(y, expected = "numeric"), y)

# Assert function ==============================================================
cnd <- arkhe:::catch_conditions(assert_function("ABC123XYZ"))
expect_inherits(cnd[[1]], "error_bad_type")

expect_identical(assert_function(mean), mean)

# Assert object attributes =====================================================
## Length ----------------------------------------------------------------------
cnd <- arkhe:::catch_conditions(assert_length(LETTERS, expected = 10))
expect_inherits(cnd[[1]], "error_bad_length")
cnd <- arkhe:::catch_conditions(assert_length(LETTERS, expected = 10, allow_empty = TRUE))
expect_inherits(cnd[[1]], "error_bad_length")
cnd <- arkhe:::catch_conditions(assert_length(numeric(), expected = 10))
expect_inherits(cnd[[1]], "error_bad_length")

expect_identical(assert_length(numeric(), expected = 10, allow_empty = TRUE), numeric())
expect_identical(assert_length(LETTERS, expected = 26), LETTERS)
expect_null(assert_length(NULL, expected = 10, allow_null = TRUE))

## Lengths ---------------------------------------------------------------------
k <- list(1:10, 1:20)
cnd <- arkhe:::catch_conditions(assert_lengths(k, expected = c(20, 10)))
expect_inherits(cnd[[1]], "error_bad_length")

expect_identical(assert_lengths(k, expected = c(10, 20)), k)

## Empty -----------------------------------------------------------------------
cnd <- arkhe:::catch_conditions(assert_empty(k))
expect_inherits(cnd[[1]], "error_bad_dimensions")

k <- list()
cnd <- arkhe:::catch_conditions(assert_filled(k))
expect_inherits(cnd[[1]], "error_bad_dimensions")
expect_identical(assert_empty(k), k)

## Dimensions ------------------------------------------------------------------
k <- matrix(1, nrow = 10, ncol = 5)
cnd <- arkhe:::catch_conditions(assert_dim(k, expected = c(5, 10)))
expect_inherits(cnd[[1]], "error_bad_dimensions")

cnd <- arkhe:::catch_conditions(assert_nrow(k, expected = 5))
expect_inherits(cnd[[1]], "error_bad_dimensions")

cnd <- arkhe:::catch_conditions(assert_ncol(k, expected = 10))
expect_inherits(cnd[[1]], "error_bad_dimensions")

expect_identical(assert_dim(k, expected = c(10, 5)), k)

## Names -----------------------------------------------------------------------
k <- vector(mode = "numeric", length = 10)
cnd <- arkhe:::catch_conditions(assert_names(k, expected = NULL))
expect_inherits(cnd[[1]], "error_bad_names")

cnd <- arkhe:::catch_conditions(assert_names(k, expected = LETTERS[11:20]))
expect_inherits(cnd[[1]], "error_bad_names")

names(k) <- LETTERS[1:10]
cnd <- arkhe:::catch_conditions(assert_names(k, expected = LETTERS[11:20]))
expect_inherits(cnd[[1]], "error_bad_names")

expect_identical(assert_names(k, expected = LETTERS[1:10]), k)

## Row/column names ------------------------------------------------------------
k <- matrix(1, nrow = 3, ncol = 3)
z <- list(LETTERS[1:3], LETTERS[4:6])

cnd <- arkhe:::catch_conditions(assert_rownames(k))
expect_inherits(cnd[[1]], "error_bad_names")

cnd <- arkhe:::catch_conditions(assert_rownames(k, expected = z[[1]]))
expect_inherits(cnd[[1]], "error_bad_names")

cnd <- arkhe:::catch_conditions(assert_colnames(k))
expect_inherits(cnd[[1]], "error_bad_names")

cnd <- arkhe:::catch_conditions(assert_colnames(k, expected = z[[2]]))
expect_inherits(cnd[[1]], "error_bad_names")

dimnames(k) <- z
expect_identical(assert_rownames(k, expected = z[[1]]), k)
expect_identical(assert_colnames(k, expected = z[[2]]), k)

# Assert missing/infinite/duplicated values ====================================
## Missing ---------------------------------------------------------------------
k <- sample(c(1, NA), size = 15, replace = TRUE)
cnd <- arkhe:::catch_conditions(assert_missing(k))
expect_inherits(cnd[[1]], "error_data_missing")

k <- sample(c(1, NaN), size = 15, replace = TRUE)
cnd <- arkhe:::catch_conditions(assert_missing(k))
expect_inherits(cnd[[1]], "error_data_missing")

expect_identical(assert_missing(numeric(3)), numeric(3))

## Infinite --------------------------------------------------------------------
k <- sample(c(1, Inf), size = 15, replace = TRUE)
cnd <- arkhe:::catch_conditions(assert_infinite(k))
expect_inherits(cnd[[1]], "error_data_infinite")

expect_identical(assert_infinite(numeric(3)), numeric(3))

## Duplicates ------------------------------------------------------------------
k <- sample(c(1, 2), size = 15, replace = TRUE)
cnd <- arkhe:::catch_conditions(assert_unique(k))
expect_inherits(cnd[[1]], "error_data_duplicates")

expect_identical(assert_unique(c(1, 2, 3)), c(1, 2, 3))

# Assert numeric data ==========================================================
k <- seq(from = -1, to = 10, by = 1)
cnd <- arkhe:::catch_conditions(assert_positive(k, strict = FALSE))
expect_inherits(cnd[[1]], "error_bad_numeric")

k <- seq(from = 0, to = 10, by = 1)
cnd <- arkhe:::catch_conditions(assert_positive(k, strict = TRUE))
expect_inherits(cnd[[1]], "error_bad_numeric")

k <- seq(from = 1, to = 10, by = 0.5)
cnd <- arkhe:::catch_conditions(assert_whole(k))
expect_inherits(cnd[[1]], "error_bad_numeric")

k <- seq(from = 1, to = 10, by = 0.5)
cnd <- arkhe:::catch_conditions(assert_whole(k, tolerance = 0.2))
expect_inherits(cnd[[1]], "error_bad_numeric")

k <- c(2, 4, 6, 8, 10)
cnd <- arkhe:::catch_conditions(assert_odd(k))
expect_inherits(cnd[[1]], "error_bad_numeric")

k <- c(1, 3, 5, 7, 9)
cnd <- arkhe:::catch_conditions(assert_even(k))
expect_inherits(cnd[[1]], "error_bad_numeric")

expect_identical(assert_positive(k), k)

# Assert count data ============================================================
x <- c(1.1, 2, 3, 4, 5)
cnd <- arkhe:::catch_conditions(assert_count(x))
expect_inherits(cnd[[1]], "error_bad_numeric")

x <- c(1, 2, 3, 4, 5)
expect_equal(assert_count(x), x)

# Assert numeric trends ========================================================
k <- c(1, 3, 5, 7, 9)
cnd <- arkhe:::catch_conditions(assert_constant(k))
expect_inherits(cnd[[1]], "error_bad_numeric")

cnd <- arkhe:::catch_conditions(assert_decreasing(k))
expect_inherits(cnd[[1]], "error_bad_numeric")

cnd <- arkhe:::catch_conditions(assert_increasing(rev(k)))
expect_inherits(cnd[[1]], "error_bad_numeric")

expect_identical(assert_increasing(k), k)

# Assert numeric relation ======================================================
x <- c(1, 2, 3, 4, 5)
y <- c(1, 6, 7, 8, 9)

cnd <- arkhe:::catch_conditions(assert_greater(x, y))
expect_inherits(cnd[[1]], "error_bad_numeric")

cnd <- arkhe:::catch_conditions(assert_lower(y, x))
expect_inherits(cnd[[1]], "error_bad_numeric")

expect_identical(assert_lower(x, y), x)

# Assert matrix ================================================================
k <- matrix(sample(1:5, 50, TRUE), nrow = 5, ncol = 10)

cnd <- arkhe:::catch_conditions(assert_square(k))
expect_inherits(cnd[[1]], "error_bad_matrix")

cnd <- arkhe:::catch_conditions(assert_symmetric(k))
expect_inherits(cnd[[1]], "error_bad_matrix")

k <- matrix(sample(1:5, 25, TRUE), nrow = 5, ncol = 5)
expect_identical(assert_square(k), k)

# matrix =======================================================================
mtx <- matrix(c(8L, NA, 1L, NA, 2L, 5L, 10L, 10L, 3L, 3L, 6L, 8L, NA, 4L, 8L),
              nrow = 5, ncol = 3)

## Find row with NA
expect_equal(detect(mtx, f = is.na, margin = 1), c(FALSE, TRUE, TRUE, TRUE, FALSE))

## Find column without any NA
no_na <- detect(mtx, f = is.na, margin = 2, negate = TRUE, all = TRUE)
expect_equal(no_na, c(FALSE, TRUE, FALSE))

# data.frame ===================================================================
df <- data.frame(
  V1 = c("A", NA, "B", NA, "C"),
  V2 = c(10L, 6L, 6L, 1L, 4L),
  V3 = c(2L, 1L, NA, 5L, 9L)
)

## Find row with NA
expect_equal(detect(df, f = is.na, margin = 1), c(FALSE, TRUE, TRUE, TRUE, FALSE))

## Find column without any NA
no_na <- detect(df, f = is.na, margin = 2, negate = TRUE, all = TRUE)
expect_equal(no_na, c(V1 = FALSE, V2 = TRUE, V3 = FALSE))

## Find numeric column
expect_equal(detect(df, f = is.numeric, margin = 2), c(V1 = FALSE, V2 = TRUE, V3 = TRUE))

# Seek -------------------------------------------------------------------------
expect_null(seek_columns(iris, select = startsWith, prefix = "sepal"))
expect_null(seek_columns(iris))
expect_identical(seek_columns(iris, select = startsWith, prefix = "Sepal"), c(1L, 2L))
expect_identical(seek_columns(iris, select = endsWith, suffix = "Width"), c(2L, 4L))
expect_identical(seek_columns(iris, names = c("Petal.Length", "Petal.Width")), c(3L, 4L))
expect_null(seek_columns(iris, names = c("XXX", "YYY")))
expect_error(seek_columns(iris, names = c(1, 2)))

x <- data.frame(
  A = LETTERS,
  B = 1:26
)
expect_null(seek_rows(x, select = startsWith, prefix = "BDX"))
rownames(x) <- sprintf("BDX%04d", 1:26)
expect_null(seek_rows(x))
expect_identical(seek_rows(x, select = startsWith, prefix = "BDX"), 1:26)
expect_identical(seek_rows(x, select = endsWith, suffix = "6"), c(6L, 16L, 26L))
expect_identical(seek_rows(x, names = c("BDX0010", "BDX0020")), c(10L, 20L))
expect_null(seek_rows(x, names = c("XXX", "YYY")))
expect_error(seek_rows(x, names = c(1, 2)))

# Get --------------------------------------------------------------------------
x <- as.matrix(x)
expect_identical(get_columns(x, select = startsWith, prefix = "A"), x[, 1, drop = FALSE])
expect_identical(get_rows(x, select = endsWith, suffix = "6"), x[c(6, 16, 26), , drop = FALSE])

# Utility predicates ===========================================================
expect_true(is_empty(matrix(nrow = 0, ncol = 0)))
expect_true(is_empty(numeric(0)))
expect_false(is_empty(numeric(1)))

expect_true(has_length(numeric(1)))
expect_true(has_length(numeric(0), n = 0))
expect_false(has_length(numeric(0)))

x <- seq_len(5)
expect_false(has_names(x))
names(x) <- letters[x]
expect_true(has_names(x))

y <- c(1, 2, NA)
z <- c(1, 2, Inf)
expect_true(has_missing(y))
expect_true(has_infinite(z))
expect_false(has_missing(z))
expect_false(has_infinite(y))
expect_false(has_missing(1))
expect_false(has_infinite(1))

a <- c(1, 1, 3)
b <- c(1, 2, 3)
expect_true(has_duplicates(a))
expect_false(has_duplicates(b))

# Type predicates ==============================================================
expect_true(is_list(list()))
expect_false(is_list(numeric(1)))

expect_true(is_atomic(numeric(1)))
expect_false(is_atomic(list()))

expect_true(is_vector(numeric(1)))
expect_true(is_vector(list()))
expect_false(is_vector(expression()))

expect_true(is_numeric(1L))
expect_true(is_numeric(1.5))
expect_false(is_numeric("A"))

expect_true(is_integer(1L))
expect_false(is_integer(1.5))

expect_true(is_double(1.5))
expect_false(is_double(1L))

expect_true(is_character("A"))
expect_false(is_character(1))

expect_true(is_logical(TRUE))
expect_false(is_logical(1))

expect_true(is_error(try(log("X"), silent = TRUE)))
expect_false(is_error(try(log(1), silent = TRUE)))

expect_true(is_message(arkhe:::catch_conditions(message("custom_message"))[[1]]))
expect_true(is_warning(arkhe:::catch_conditions(warning("custom_warning"))[[1]]))

# Scalar type predicates =======================================================
expect_true(is_scalar_list(list(1)))
expect_false(is_scalar_list(list()))
expect_false(is_scalar_list(list(1, 2)))

expect_true(is_scalar_atomic(numeric(1)))
expect_false(is_scalar_atomic(numeric(0)))
expect_false(is_scalar_atomic(numeric(2)))

expect_true(is_scalar_vector(numeric(1)))
expect_false(is_scalar_vector(numeric(0)))
expect_false(is_scalar_vector(numeric(2)))

expect_true(is_scalar_numeric(numeric(1)))
expect_false(is_scalar_numeric(numeric(0)))
expect_false(is_scalar_numeric(numeric(2)))

expect_true(is_scalar_integer(integer(1)))
expect_false(is_scalar_integer(integer(0)))
expect_false(is_scalar_integer(integer(2)))

expect_true(is_scalar_double(double(1)))
expect_false(is_scalar_double(double(0)))
expect_false(is_scalar_double(double(2)))

expect_true(is_scalar_character(character(1)))
expect_false(is_scalar_character(character(0)))
expect_false(is_scalar_character(character(2)))

expect_true(is_scalar_logical(logical(1)))
expect_false(is_scalar_logical(logical(0)))
expect_false(is_scalar_logical(logical(2)))

# Numeric predicates ===========================================================
expect_true(is_zero(0))
expect_false(is_zero(1))

expect_inherits(is_odd(c(1, 3, 5, 7, 9)), "logical")
expect_false(is_odd(2))
expect_false(is_even(1))

expect_inherits(is_positive(c(0, 1, 2, 3, 4)), "logical")
expect_true(all(is_positive(c(0, 1, 2, 3, 4), strict = FALSE)))
expect_false(all(is_positive(c(0, 1, 2, 3, 4), strict = TRUE)))
expect_error(is_positive(LETTERS))

expect_inherits(is_negative(c(0, -1, -2, -3, -4)), "logical")
expect_true(all(is_negative(c(0, -1, -2, -3, -4), strict = FALSE)))
expect_false(all(is_negative(c(0, -1, -2, -3, -4), strict = TRUE)))
expect_error(is_negative(LETTERS))

expect_inherits(is_whole(c(0, 1, 2, 3, 4)), "logical")
expect_true(all(is_whole(c(0, 1, 2, 3, 4))))
expect_true(is_whole(0.1, tolerance = 0.1))
expect_false(is_whole(0.1))
expect_error(is_whole(LETTERS))

# Trend predicates =============================================================
expect_true(is_constant(c(1, 1, 1, 1, 1)))
expect_true(is_constant(c(1, 1.1, 1.2, 1.3, 1.4), tolerance = 0.5))
expect_true(is_constant(c(1, 1, 1, NA, 1), na.rm = TRUE))
expect_equal(is_constant(c(1, 1, 1, NA, 1), na.rm = FALSE), NA)
expect_false(is_constant(c(1, 2, 1, 1, 1)))
expect_error(is_constant(LETTERS))

expect_true(is_increasing(c(1, 2, 3, 4, 5)))
expect_true(is_increasing(c(1, 1, 1, 1, 1)))
expect_true(is_increasing(c(1, 2, 3, NA, 5), na.rm = TRUE))
expect_equal(is_increasing(c(1, 2, 3, NA, 5), na.rm = FALSE), NA)
expect_false(is_increasing(c(5, 4, 3, 2, 1)))
expect_error(is_increasing(LETTERS))

expect_true(is_decreasing(c(5, 4, 3, 2, 1)))
expect_true(is_decreasing(c(1, 1, 1, 1, 1)))
expect_true(is_decreasing(c(5, 4, 3, NA, 1), na.rm = TRUE))
expect_equal(is_decreasing(c(5, 4, 3, NA, 1), na.rm = FALSE), NA)
expect_false(is_decreasing(c(1, 2, 3, 4, 5)))
expect_error(is_decreasing(LETTERS))

x <- c(1, 6, 7, 8, 9)
y <- c(1, 2, 3, 4, 5)
expect_true(is_greater(x, y, strict = FALSE))
expect_false(is_greater(x, y, strict = TRUE))
expect_false(is_greater(y, x, strict = TRUE))
expect_true(is_lower(y, x, strict = FALSE))
expect_false(is_lower(y, x, strict = TRUE))
expect_false(is_lower(x, y, strict = TRUE))
expect_error(is_lower(x, LETTERS))
expect_error(is_lower(LETTERS, y))

# Matrix predicates ============================================================
expect_true(is_square(matrix(nrow = 3, ncol = 3)))
expect_false(is_square(matrix(nrow = 1, ncol = 3)))
expect_false(is_square(c(1, 2, 3)))

mtx1 <- matrix(sample(seq_len(25), size = 25), nrow = 5, ncol = 5)
mtx2 <- t(mtx1)
mtx2[lower.tri(mtx2)] <- mtx1[lower.tri(mtx1)]
expect_true(is_symmetric(mtx2))
expect_false(is_symmetric(mtx1))
expect_false(is_symmetric(c(1, 2, 3)))

mtx <- matrix(c(8L, 10L, 1L, 10L, 2L, 5L, 10L, 10L, 3L, 3L, 6L, 8L, 4L, 4L, 8L),
              nrow = 5, ncol = 3)

## Nothing to remove
clean <- discard_rows(mtx, f = is_zero, all = FALSE)
expect_equal(dim(clean), dim(mtx))
expect_message(discard_rows(mtx, f = is_zero, verbose = TRUE))

mtx[1, ] <- 0 # Add zeros

## Nothing to remove
clean <- discard_columns(mtx, f = is_zero, all = TRUE)
expect_equal(dim(clean), dim(mtx))
expect_message(discard_columns(mtx, f = is_zero, all = TRUE, verbose = TRUE))

mtx[, 1] <- 0 # Add zeros

## Remove rows
clean_row <- discard_rows(mtx, f = is_zero, all = TRUE)
expect_equal(nrow(clean_row), nrow(mtx) - 1L)
expect_equal(ncol(clean_row), ncol(mtx))
expect_message(discard_rows(mtx, f = is_zero, all = TRUE, verbose = TRUE))

## Remove columns
clean_col <- discard_columns(mtx, f = is_zero, all = TRUE)
expect_equal(ncol(clean_col), ncol(mtx) - 1L)
expect_equal(nrow(clean_col), nrow(mtx))
expect_message(discard_columns(mtx, f = is_zero, all = TRUE, verbose = TRUE))

# Whitespace ===================================================================
x <- data.frame(A = c("  Both ", "  Left", "Right  ", "\n\nLeft\n  Middle Right\t"), B = 1:4)
xb <- xl <- xr <- x
xb$A <- trimws(x$A, which = "both")
xl$A <- trimws(x$A, which = "left")
xr$A <- trimws(x$A, which = "right")

expect_equal(clean_whitespace(x, which = "both", squish = FALSE), xb)
expect_equal(clean_whitespace(x, which = "left", squish = FALSE), xl)
expect_equal(clean_whitespace(x, which = "right", squish = FALSE), xr)

xb$A <- trimws(gsub(pattern = "\\s+", replacement = " ", x = x$A), which = "both")
expect_equal(clean_whitespace(x, which = "both", squish = TRUE), xb)
expect_equal(clean_whitespace(as.matrix(x), which = "both", squish = TRUE), as.matrix(xb))

## Read fake data
artefacts <- read.csv(system.file("tinytest", "fake.csv", package = "arkhe"))

# Missing values ===============================================================
## Nothing to remove
no_rows <- remove_NA(artefacts, margin = 1, all = TRUE)
expect_equal(dim(no_rows), dim(artefacts))
no_cols <- remove_NA(artefacts, margin = 2, all = TRUE)
expect_equal(dim(no_cols), dim(artefacts))

## Remove rows
clean_row <- remove_NA(artefacts, margin = 1, all = FALSE)
expect_equal(dim(clean_row), dim(artefacts) - c(35, 0))

## Remove columns
clean_col <- remove_NA(artefacts, margin = 2, all = FALSE)
expect_equal(dim(clean_col), dim(artefacts) - c(0, 4))

# Infinite values ==============================================================
## Nothing to remove
no_rows <- remove_Inf(artefacts, margin = 1, all = TRUE)
expect_equal(dim(no_rows), dim(artefacts))
no_cols <- remove_Inf(artefacts, margin = 2, all = TRUE)
expect_equal(dim(no_cols), dim(artefacts))

## Remove rows
clean_row <- remove_Inf(artefacts, margin = 1, all = FALSE)
expect_equal(dim(clean_row), dim(artefacts) - c(1, 0))

## Remove columns
clean_col <- remove_Inf(artefacts, margin = 2, all = FALSE)
expect_equal(dim(clean_col), dim(artefacts) - c(0, 2))

# Zeros ========================================================================
## Nothing to remove
no_rows <- remove_zero(artefacts, margin = 1, all = TRUE)
expect_equal(dim(no_rows), dim(artefacts))
no_cols <- remove_zero(artefacts, margin = 2, all = TRUE)
expect_equal(dim(no_cols), dim(artefacts))

## Remove rows
clean_row <- remove_zero(artefacts, margin = 1, all = FALSE)
expect_equal(dim(clean_row), dim(artefacts) - c(19, 0))

## Remove columns
clean_col <- remove_zero(artefacts, margin = 2, all = FALSE)
expect_equal(dim(clean_col), dim(artefacts) - c(0, 2))

# Empty strings ================================================================
## Nothing to remove
no_rows <- remove_empty(artefacts, margin = 1, all = TRUE)
expect_equal(dim(no_rows), dim(artefacts))
no_cols <- remove_empty(artefacts, margin = 2, all = TRUE)
expect_equal(dim(no_cols), dim(artefacts))

## Remove rows
clean_row <- remove_empty(artefacts, margin = 1, all = FALSE)
expect_equal(dim(clean_row), dim(artefacts) - c(10, 0))

## Remove columns
clean_col <- remove_empty(artefacts, margin = 2, all = FALSE)
expect_equal(dim(clean_col), dim(artefacts) - c(0, 1))

# Constant columns =============================================================
df1 <- data.frame(A = 1, B = 1:3)
df2 <- data.frame(B = 1:3)

expect_equal(remove_constant(df1), df2)

df1[1, 1] <- NA # Add NA
expect_equal(remove_constant(df1), df1)

expect_equal(remove_constant(df1, na.rm = TRUE), df2)

# matrix =======================================================================
mtx <- matrix(c(8L, NA, 1L, NA, 2L, 5L, 10L, 10L, 3L, 3L, 6L, 8L, NA, 4L, 8L),
              nrow = 5, ncol = 3)

## Count missing values in rows
expect_equal(count(mtx, f = is.na, margin = 1), c(0, 1, 1, 1, 0))
## Count non-missing values in columns
no_na <- count(mtx, f = is.na, margin = 2, negate = TRUE)
expect_equal(no_na, c(3, 5, 4))

# data.frame ===================================================================
df <- data.frame(
  V1 = c("A", NA, "B", NA, "C"),
  V2 = c(10L, 6L, 6L, 1L, 4L),
  V3 = c(2L, 1L, NA, 5L, 9L)
)

## Count missing values in rows
expect_equal(count(df, f = is.na, margin = 1), c(0, 1, 1, 1, 0))
## Count non-missing values in columns
no_na <- count(df, f = is.na, margin = 2, negate = TRUE)
expect_equal(no_na, c(V1 = 3, V2 = 5, V3 = 4))

## No margin
test <- df
test[] <- lapply(X = df, FUN = is.na)
expect_equal(count(df, f = is.na, margin = NULL), test)
